=== debian/changelog ===
openvdb (6.2.1-8ubuntu1) focal; urgency=medium

  * Don't request a specific python3 version.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 22 Feb 2020 09:04:59 +0100

openvdb (6.2.1-8) unstable; urgency=medium

  * d/control: Keep explicit X-Python3-Version reference

 -- Mathieu Malaterre <malat@debian.org>  Fri, 21 Feb 2020 10:21:12 +0100

openvdb (6.2.1-7) unstable; urgency=medium

  * d/patches: Resolve all symbols of python module
  * d/patches: Fix unit tests
  * d/control: Remove explicit X-Python3-Version reference

 -- Mathieu Malaterre <malat@debian.org>  Fri, 21 Feb 2020 08:52:44 +0100

openvdb (6.2.1-6) experimental; urgency=medium

  * d/rules: Add missing dependency on help2man

 -- Mathieu Malaterre <malat@debian.org>  Wed, 19 Feb 2020 09:15:36 +0100

openvdb (6.2.1-5) experimental; urgency=medium

  * d/rules: Fix compilation issue on mipsel
  * d/rules: do not build test with nocheck in DEB_BUILD_OPTIONS
  * d/rules: Simplify python version handling. Closes: #948186
  * d/rules: Simplify manpages generation
  * d/rules: Remove static lib for now
  * d/rules: Remove RPATH since not used
  * d/patches: Remove explicit -std=c++11 from compilation line

 -- Mathieu Malaterre <malat@debian.org>  Tue, 18 Feb 2020 22:17:59 +0100

openvdb (6.2.1-4) experimental; urgency=medium

  * d/control: Make sure to use cmake after 3.14 for numpy/cmake
  * d/control: Update Std-Vers to 4.5.0, no changes needed
  * d/control: add dep libxxf86vm-dev
  * d/patch: Add support for arches where -latomic is required

 -- Mathieu Malaterre <malat@debian.org>  Sun, 16 Feb 2020 21:04:20 +0100

openvdb (6.2.1-3) experimental; urgency=medium

  * d/patches: Make tbb inspection portable

 -- Mathieu Malaterre <malat@debian.org>  Mon, 11 Nov 2019 18:14:12 +0100

openvdb (6.2.1-2) experimental; urgency=medium

  [ Mathieu Malaterre ]
  * d/control: Add pkg-config dependency

  [ GSR ]
  * libopenvdb-dev should depend on libtbb-dev & libblosc-dev. Closes: #917306

 -- Mathieu Malaterre <malat@debian.org>  Sun, 10 Nov 2019 17:54:58 +0100

openvdb (6.2.1-1) experimental; urgency=medium

  * New upstream version 6.2.1
  * d/patches: refresh patches, remove unneeded
  * d/patches: Force python3 system inspection
  * d/rules: Switch to cmake build system
  * d/control: Update missing dependencies
  * d/control: Explicit reference X-Python3-Version: 3.7
  * d/control: Update reference to SONAME
  * d/patches: Add python3 patch
  * d/manpages: Refresh manpages

 -- Mathieu Malaterre <malat@debian.org>  Fri, 08 Nov 2019 14:01:51 +0100
